import java.util.Scanner;
// WARNING: All other imports are forbidden!

/* NB: For the judge to run the program, do not modify the declaration of the class Main or
 *     method main() below. The class has to be declared as "class Main { ... }"
 *     and the method as "public static void main(String[] args) { ... }" */
class Main {

	public static void main(String[] args) {

		// Read from the standard input with java.util.Scanner
		Scanner scanner = new Scanner(System.in);
		
		// Read the number of cases and loop over the cases
		int case_no, cases = scanner.nextInt();
		for (case_no = 0; case_no < cases; case_no++) {
			
			// Read the road length, tower range, number of locations
			int L = scanner.nextInt();
			int R = scanner.nextInt();
			int n = scanner.nextInt();
			int i;
			
			// Array of tower locations on the road, sorted
			int[] d = new int[n];
			for (i = 0; i < n; i++) {
				d[i] = scanner.nextInt();
			}
			
			// Array of tower location costs
			int[] c = new int[n];
			for (i = 0; i < n; i++) {
				c[i] = scanner.nextInt();
			}

			int[] with_last = new int[n];
			for (i = 0; i < n; i++) {
				if (d[i] <= R) {
					with_last[i] = c[i];
				} else {
					with_last[i] = Integer.MAX_VALUE;
					int prev;
					for (prev = i - 1; prev >= 0 && d[i] - d[prev] <= 2 * R; prev --) {
						int with_prev = c[i] + with_last[prev];
						if (with_prev < with_last[i])
							with_last[i] = with_prev;
					}
				}
				if (with_last[i] == Integer.MAX_VALUE) 
					System.err.println("Task " + case_no + ": Vertex " + i + " has no predecessor.");
			}
			
			int min_cost = Integer.MAX_VALUE, last;
			for (last = n - 1; last >= 0 && L - d[last] <= R; last --) {
				if (with_last[last] < min_cost)
					min_cost = with_last[last];
			}
			
			System.out.println(min_cost);
		}
		scanner.close();
	}
}
